package org.jboss.test.remoting.tests;

import java.io.Serializable;

import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.jboss.remoting.Client;
import org.jboss.remoting.InvokerLocator;

public class WriteTimeoutTest
{
   static Logger log = Logger.getLogger(WriteTimeoutTest.class);
   static int COUNT = 100000;
   public static void main(String[] args)
   {
      try
      {
         Logger.getLogger("org.jboss.remoting").setLevel(Level.INFO);
         Logger.getLogger("org.jboss.test.remoting").setLevel(Level.INFO);
         String pattern = "[%d{ABSOLUTE}] [%t] %5p (%F:%L) - %m%n";
         PatternLayout layout = new PatternLayout(pattern);
         ConsoleAppender consoleAppender = new ConsoleAppender(layout);
         Logger.getRootLogger().addAppender(consoleAppender);
         
         Client client = new Client(new InvokerLocator("socket://192.168.2.5:5555/?writeTimeout=1000"));
         client.connect();
//         log.info(" response: " + client.invoke("abc"));
//         log.info(" sleeping");
//         Thread.sleep(5000);
//         log.info(" invoking");
////         byte b[] = new byte[10000000];
//         log.info(" response: " + client.invoke(new Payload()));
         
         long start = System.currentTimeMillis();
         for (int i = 0; i < COUNT; i++)
         {
            client.invoke("abc");
         }
         log.info("with write timeout: " + (System.currentTimeMillis() - start));
         
         client.disconnect();
         client = new Client(new InvokerLocator("socket://192.168.2.5:5555"));
         client.connect();
         start = System.currentTimeMillis();
         for (int i = 0; i < COUNT; i++)
         {
            client.invoke("abc");
         }
         log.info("without write timeout: " + (System.currentTimeMillis() - start));
      }
      catch (Throwable e)
      {
         log.info(" exception", e);
      }
   }
   
   static class Payload implements Serializable
   {
      Object[] os = new Object[1000000];
   }
}
